$Pref::RHMG::ReloadSpeed = 1;


AddDamageType("RHMG_M2",   '<bitmap:add-ons/Weapon_Gun/CI_gun> %1',    '%2 <bitmap:add-ons/Weapon_Gun/CI_gun> %1',1,1);
datablock ProjectileData(RHMG_M2Projectile : gunProjectile)
{
	directDamage        = 200;
	muzzleVelocity      = 200;
	velInheritFactor    = 0;
	isBallistic         = true;
	gravityMod = 0.0;
	
	explosion           = RHMG_M2Explosion;
	
   impactImpulse	     = 800;
   verticalImpulse	  = 800;
	
   directDamageType    = $DamageType::RHMG_M2;
   radiusDamageType    = $DamageType::RHMG_M2;
   
	brickExplosionRadius = 0.5;
	brickExplosionImpact = false;          //destroy a brick if we hit it directly?
	brickExplosionForce  = 5;             
	brickExplosionMaxVolume = 5;          //max volume of bricks that we can destroy
	brickExplosionMaxVolumeFloating = 10;
	
	// sniper range is infinite
	DamageFalloffEffective = "";
	DamageFalloffRange = "";
	DamageFalloffDelta = "";
	
	effectiveRange		= 300;	// effective range
	totalRange			= 16000;	// total range
	
	unitsPerSecond		= 2000;	// how many torque units the projectile should travel in one second
							// the default static shape is designed for ranges in
							// the 800 - 2000 u/s range, anything slower will lag
							// visually.
	
	gravityScale 		= 2.0;	// scale gravity effect outside effective range
	swayMod			= 0.0;	// scale wind effect outside effective range
	
	spawnFakeProjectiles   = true;	// use animated static shape to give the illusion of a visible projectile
	tracerEffect		= false;	// use red tracer effect
	
	scaleCalibre		= 0.6;	// bullet scale on diameter axis
	scaleLength		= 1;	       // bullet scale on length axis
	
	isSupersonic		= false;	// enable/disable supersonic crack effect on near miss
	isSuppressive		= false;	// enable/disable suppression effects
	suppressionRadius       = 0;	// distance the bullet must near-miss the player by in order to cause suppression effects
	
	allowRicochet		= false;	// enable/disable bullet ricochet
	
	threatLevel = 20;
	uiName = "";
};


datablock AudioProfile(RHMG_M2Shot1)
{
   filename    = "./sound/M2/init_1.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(RHMG_M2Shot2)
{
   filename    = "./sound/M2/init_2.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(RHMG_M2Shot3)
{
   filename    = "./sound/M2/init_3.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(RHMG_M2Tail1)
{
   filename    = "./sound/M2/tail_1.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(RHMG_M2Tail2)
{
   filename    = "./sound/M2/tail_2.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(RHMG_M2TriggerSound)
{
   filename    = "./sound/M2/trigger.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(RHMG_M2Trigger2Sound)
{
   filename    = "./sound/M2/trigger2.wav";
   description = AudioDefault3d;
   preload = true;
};





datablock AudioProfile(RHMG_MagoutSound)
{
   filename    = "./sound/M2/mag_out.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(RHMG_MaginSound)
{
   filename    = "./sound/M2/mag_in.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(RHMG_RoofUpSound)
{
   filename    = "./sound/M2/roof_up.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(RHMG_RoofDownSound)
{
   filename    = "./sound/M2/roof_down.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(RHMG_BeltSound)
{
   filename    = "./sound/M2/belt.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(RHMG_ChargeSound)
{
   filename    = "./sound/M2/charge.wav";
   description = AudioDefault3d;
   preload = true;
};


datablock AudioProfile(RHMG_HeatSound)
{
   filename    = "./sound/M2/overheat.wav";
   description = AudioDefault3d;
   preload = true;
};


datablock TSShapeConstructor(R_M2Dts)
{
	baseShape  = "./M2.dts";
	sequence0  = "./m2.dsq";
};

datablock PlayerData(R_M2Player)
{
   renderFirstPerson = true;
   emap = false;
   
   className = Armor;
   shapeFile = "./M2.dts"; //BrowningM2.dts";
   cameraMaxDist = 8;
   cameraTilt = 0.261;
   cameraVerticalOffset = 2.3;
     
   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   useEyePoint = false;
   
   
   //debrisShapeName = "~/data/player/debris_player.dts";
   //debris = horseDebris;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 3.0;

   mass = 200000;
   drag = 1;
   density = 5;
   maxDamage = 250;
   maxEnergy =  10;
   repairRate = 0.33;

   rechargeRate = 0.4;

   runForce = 1000;
   runEnergyDrain   = 0;
   minRunEnergy     = 0;
   maxForwardSpeed  = 0;
   maxBackwardSpeed = 0;
   maxSideSpeed     = 0;

   maxForwardCrouchSpeed  = 0;
   maxBackwardCrouchSpeed = 0;
   maxSideCrouchSpeed     = 0;

   maxUnderwaterForwardSpeed  = 0;
   maxUnderwaterBackwardSpeed = 0;
   maxUnderwaterSideSpeed     = 0;

   jumpForce       = 0; 
   jumpEnergyDrain = 0;
   minJumpEnergy   = 0;
   jumpDelay       = 0;

   minJetEnergy   = 0;
	jetEnergyDrain = 0;
	canJet         = 0;

   minImpactSpeed   = 250;
   speedDamageScale = 3.8;

   boundingBox			= vectorScale("1 0.75 0.75", 4); 
   crouchBoundingBox	= vectorScale("1 0.75 0.75", 4); 
   
   pickupRadius = 0.75;
   
   // Foot Prints
   //decalData   = HorseFootprint;
   //decalOffset = 0.25;
	
   jetEmitter        = "";
   jetGroundEmitter  = "";
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 85;
   jumpSurfaceAngle = 86;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

   JumpSound = "";

   // Footstep Sounds
   //FootSoftSound        = HorseFootFallSound;
   //FootHardSound        = HorseFootFallSound;
   //FootMetalSound       = HorseFootFallSound;
   //FootSnowSound        = HorseFootFallSound;
   //FootShallowSound     = HorseFootFallSound;
   //FootWadingSound      = HorseFootFallSound;
   //FootUnderwaterSound  = HorseFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   //impactWaterEasy      = ImpactLightWaterEasySound;
   //impactWaterMedium    = ImpactLightWaterMediumSound;
   //impactWaterHard      = ImpactLightWaterHardSound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	
	uiName = "Heavy Machine Gun";
	rideable = true;
   lookUpLimit = 0.5;
   lookDownLimit = 0.5;

	canRide = true;
	showEnergyBar = false;
	paintable = true;

	brickImage = horseBrickImage;	//the imageData to use for brick deployment

   numMountPoints = 1;
   mountThread[0] = "sit";

   //protection for passengers
   protectPassengersBurn   = true;  //protect passengers from the burning effect of explosions?
   protectPassengersRadius = false;  //protect passengers from radius damage (explosions) ?
   protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?

   useCustomPainEffects = true;
   PainHighImage = "";
   PainMidImage  = "";
   PainLowImage  = "";
   painSound     = "";
   deathSound    = "";
   
   
   isRHMG = true;
   RHMGtype = 0;
   
   //explosionProjectile = M2TurretExplosionProjectile;
   //fireImageDatablock = "R_M2SmokeImage";
   //isTechnicalTurret = true;
};

function R_M2Player::onAdd(%this, %obj)
{
	%obj.hideNode("Lid1");
	%obj.hideNode("Trigger1");
	%obj.hideNode("heat");
	%obj.ammo = 200;
}

// function R_M2Player::onMount(%this, %obj)
// {
	// Parent::onMount(%this, %obj);
// }


function Player::RHMG_M2TailSound(%obj, %pitch)
{
	$oldTimescale = getTimescale();
	setTimescale(%pitch);
	
	if(isObject(%obj.getMountedObject(0)))
		serverPlay3D("RHMG_M2Tail" @ getRandom(1, 2), vectorAdd(%obj.getMountedObject(0).getHackPosition(), "0 0 0.1"));
	else
		serverPlay3D("RHMG_M2Tail" @ getRandom(1, 2), %obj.getHackPosition());
		
	setTimescale($oldTimescale);
}
function Player::RHMG_M2FireSound(%obj)
{
	%pitch = 1 + (%obj.cookoff / 150);
		
	$oldTimescale = getTimescale();
	setTimescale(%pitch);
	
	if(isObject(%obj.getMountedObject(0)))
		serverPlay3D("RHMG_M2Shot" @ getRandom(1, 3), %obj.getMountedObject(0).getHackPosition());
	else
		serverPlay3D("RHMG_M2Shot" @ getRandom(1, 3), %obj.getHackPosition());
	
	setTimescale($oldTimescale);
	
	%obj.RHMGTailSoundQuota = %obj.schedule(100 / %pitch, RHMG_M2TailSound, %pitch);
}



function Player::RHMG_M2_Flash(%obj)
{
	%obj.unMountImage(0);
	%obj.schedule(33, mountImage, RHMG_MuzzleFlashImage, 0);
	//%obj.schedule(50, unMountImage, 0);
}
function Player::RHMG_M2_Eject(%obj)
{
	%obj.unMountImage(1);
	%obj.schedule(33, mountImage, RHMG_EjectImage, 1);
}
function Player::RHMG_M2_Overheat(%obj)
{
	%obj.unMountImage(2);
	%obj.schedule(33, mountImage, RHMG_OverheatImage, 2);	
}
function Player::RHMG_M2_Jam(%obj)
{
	%obj.unMountImage(2);
	%obj.schedule(33, mountImage, RHMG_JamImage, 2);	
}
function Player::RHMG_M2_EjectMagazine(%obj)
{
	%obj.unMountImage(2);
	%obj.schedule(33, mountImage, RHMG_M2EjectMagazineImage, 2);	
}




///// Reloading ///////

function Player::RHMG_M2_StartReload(%obj)
{
	%obj.RHMG_M2CoolLoop();
	%obj.RHMG_ReloadStage = 1;
	if(!isObject(%obj.getMountedObject(0)))
	{
		%obj.RHMG_M2TriggerUp();
		%obj.RHMG_reloadPaused = true;
		return;
	}

	if(%obj.ammo <= 0)
	{
		%obj.schedule(500, RHMG_M2_RemoveMagazine);
	}
	else
	{
		// need to open lid and clear belt
		%obj.schedule(500, RHMG_M2_PreLidOpen);
	}
}

function Player::RHMG_M2_PreLidOpen(%obj)
{
	
	%obj.lidOpen = true;

	%obj.RHMG_ReloadStage = 2;
	if(!isObject(%obj.getMountedObject(0)))
	{
		%obj.RHMG_M2TriggerUp();
		%obj.RHMG_reloadPaused = true;
		return;
	}
	
	%obj.playThread(0, Manip);
	
	%obj.unhideNode("Lid1");
	%obj.hideNode("Lid0");
	
	serverPlay3D("RHMG_RoofUpSound", %obj.getHackPosition());
	
	%obj.schedule(1000 * $Pref::RHMG::ReloadSpeed, RHMG_M2_RemoveBelt);
}


function Player::RHMG_M2_RemoveBelt(%obj)
{

	%obj.RHMG_ReloadStage = 3;
	if(!isObject(%obj.getMountedObject(0)))
	{
		%obj.RHMG_M2TriggerUp();
		%obj.RHMG_reloadPaused = true;
		return;
	}

	%obj.hideNode("bullet0");
	%obj.hideNode("bullet1");
	%obj.hideNode("bullet2");
	%obj.hideNode("bullet3");
	%obj.hideNode("bullet4");
	%obj.hideNode("bullet5");
	%obj.hideNode("bullet6");
	
	%obj.playThread(0, Manip);
	
	serverPlay3D("RHMG_BeltSound", %obj.getHackPosition());
	
	%obj.schedule(1000 * $Pref::RHMG::ReloadSpeed, RHMG_M2_RemoveMagazine);
}

function Player::RHMG_M2_RemoveMagazine(%obj)
{
	%obj.RHMG_ReloadStage = 4;
	if(!isObject(%obj.getMountedObject(0)))
	{
		%obj.RHMG_M2TriggerUp();
		%obj.RHMG_reloadPaused = true;
		return;
	}
	
	%obj.playThread(0, Manipsmall);
	%obj.RHMG_M2_EjectMagazine();
	
	serverPlay3D("RHMG_MagoutSound", %obj.getHackPosition());
	
	%obj.hideNode("mag");
	%obj.schedule(2500 * $Pref::RHMG::ReloadSpeed, RHMG_M2_InsertMagazine);
}

function Player::RHMG_M2_InsertMagazine(%obj)
{
	%obj.RHMG_ReloadStage = 5;
	if(!isObject(%obj.getMountedObject(0)))
	{
		%obj.RHMG_M2TriggerUp();
		%obj.RHMG_reloadPaused = true;
		return;
	}
	
	%obj.playThread(0, Manipsmall);
	
	serverPlay3D("RHMG_MaginSound", %obj.getHackPosition());
	
	%obj.unhideNode("mag");
	%obj.schedule(1000 * $Pref::RHMG::ReloadSpeed, RHMG_M2_LidOpen);
}

function Player::RHMG_M2_LidOpen(%obj)
{
	if(%obj.lidOpen)
	{
		%obj.RHMG_M2TriggerUp();
		%obj.RHMG_M2_PlaceBelt();
		return;
	}

	%obj.RHMG_ReloadStage = 6;
	if(!isObject(%obj.getMountedObject(0)))
	{
		%obj.RHMG_reloadPaused = true;
		return;
	}
	
	%obj.playThread(0, Manip);
	
	serverPlay3D("RHMG_RoofUpSound", %obj.getHackPosition());
	
	%obj.unhideNode("Lid1");
	%obj.hideNode("Lid0");
	%obj.schedule(1000 * $Pref::RHMG::ReloadSpeed, RHMG_M2_PlaceBelt);
}

function Player::RHMG_M2_PlaceBelt(%obj)
{
	%obj.RHMG_ReloadStage = 7;
	if(!isObject(%obj.getMountedObject(0)))
	{
		%obj.RHMG_M2TriggerUp();
		%obj.RHMG_reloadPaused = true;
		return;
	}
	
	%obj.playThread(0, Manipsmall);
	serverPlay3D("RHMG_BeltSound", %obj.getHackPosition());

	%obj.unhideNode("bullet0");
	%obj.unhideNode("bullet1");
	%obj.unhideNode("bullet2");
	%obj.unhideNode("bullet3");
	%obj.unhideNode("bullet4");
	%obj.unhideNode("bullet5");
	%obj.unhideNode("bullet6");
	%obj.ammo = 200;
	
	%obj.schedule(1500 * $Pref::RHMG::ReloadSpeed, RHMG_M2_CloseLid);
}

function Player::RHMG_M2_CloseLid(%obj)
{
	%obj.lidOpen = false;

	%obj.RHMG_ReloadStage = 8;
	if(!isObject(%obj.getMountedObject(0)))
	{
		%obj.RHMG_M2TriggerUp();
		%obj.RHMG_reloadPaused = true;
		return;
	}
	
	%obj.playThread(0, Manip);
	serverPlay3D("RHMG_RoofDownSound", %obj.getHackPosition());
	
	%obj.unhideNode("Lid0");
	%obj.hideNode("Lid1");
	%obj.schedule(1000 * $Pref::RHMG::ReloadSpeed, RHMG_M2_Charge);
}

function Player::RHMG_M2_Charge(%obj)
{
	%obj.RHMG_M2TriggerUp();
	%obj.RHMG_ReloadStage = 9;
	if(!isObject(%obj.getMountedObject(0)))
	{
		%obj.RHMG_M2TriggerUp();
		%obj.RHMG_reloadPaused = true;
		return;
	}
	
	%obj.playThread(0, charge);
	serverPlay3D("RHMG_ChargeSound", %obj.getHackPosition());
	
	%obj.schedule(800, RHMG_M2_FinishReload);
}

function Player::RHMG_M2_FinishReload(%obj)
{
	%obj.RHMG_ReloadStage = 0;
}

function Player::RHMG_M2_ContinueReload(%obj)
{
	switch(%obj.RHMG_ReloadStage)
	{
		case 0:
			return;
		
		case 1:
			%obj.RHMG_M2_StartReload();
		
		case 2:
			%obj.RHMG_M2_PreLidOpen();
		
		case 3:
			%obj.RHMG_M2_RemoveBelt();
		
		case 4:
			%obj.RHMG_M2_RemoveMagazine();
		
		case 5:
			%obj.RHMG_M2_InsertMagazine();
		
		case 6:
			%obj.RHMG_M2_LidOpen();
		
		case 7:
			%obj.RHMG_M2_PlaceBelt();
		
		case 8:
			%obj.RHMG_M2_CloseLid();
		
		case 9:
			%obj.RHMG_M2_Charge();
			
		default:
			%obj.RHMG_M2_StartReload();
		
	}
}

///// Reloading ///////




function Player::RHMG_M2FireOnce(%obj)
{
	if(%obj.RHMG_ReloadStage != 0)
	{
		if(%obj.RHMG_reloadPaused)
		{
			%obj.RHMG_reloadPaused = false;
			%obj.RHMG_M2_ContinueReload();
		}
		return;
	}


	if(%obj.ammo <= 0)
	{
		//%obj.RHMG_M2TriggerUp();
		
		%obj.RHMG_M2_StartReload();
		
		cancel(%obj.RHMGFireLoop);
		cancel(%obj.RHMGCoolLoop);
		%obj.RHMG_M2CoolLoop();
		return;
	}
	
	%player = %obj.getMountedObject(0);
	%muzzlePoint = getWords(%obj.getSlotTransform(1), 0, 2);
	%muzzleVector = %obj.getEyeVector();
	%projectileDatablock = RHMG_M2Projectile;
	%spread = mClampF(%obj.cookoff * 0.00001, 0.00005, 0.0003);
	%zero = 0;
	
	if($Pref::RHMG_FastProjectile)
	{
		createStaticHitscan_rWepPack(%player, %muzzlePoint, %muzzleVector, %projectileDatablock, %spread, %zero);
	}
	else
	{
		%p = new Projectile()
		{
		   dataBlock = RHMG_M2Projectile;
		   initialPosition = %muzzlePoint;
		   initialVelocity = vectorScale(%muzzleVector, 200);
		   sourceObject = %client.player;
		   client = %client;
		   //sourceSlot = 0;
		   //originPoint = %mount.getSlotTransform(1);
		};
		MissionCleanup.add(%p);
	}
	
	%obj.RHMG_M2_Flash();
	%obj.RHMG_M2_Eject();
	
	if(%obj.ammo < 7)
		%obj.hideNode("bullet0");
	if(%obj.ammo < 6)
		%obj.hideNode("bullet1");
	if(%obj.ammo < 5)
		%obj.hideNode("bullet2");
	if(%obj.ammo < 4)
		%obj.hideNode("bullet3");
	if(%obj.ammo < 3)
		%obj.hideNode("bullet4");
	if(%obj.ammo < 2)
		%obj.hideNode("bullet5");

	if($Pref::RHMG_Ammo)
		%obj.ammo--;
	
	if(%obj.ammo < 1)
		%obj.hideNode("bullet6");

	cancel(%obj.RHMGCoolLoop);
	cancel(%obj.RHMGTailSoundQuota);

	if(!%obj.RHMG_HasFiredOnce)
	{
		%obj.RHMG_HasFiredOnce = true;
		%obj.setNodeColor("heat", "1 1 1 0");
		%obj.unhideNode("heat");
	}
	

	%obj.playThread(0, fire);
	%obj.RHMG_M2FireSound();
	
	if($Pref::RHMG_Heating)
		%obj.cookoff += (2.5 / 8);
	
	if(%obj.cookoff > 50)
		%obj.cookoff = 50;
	
	%barrelTrans = (%obj.cookoff / 50) * 0.25;
	
	%obj.setNodeColor("heat", "1 1 1" SPC %barrelTrans);
	//%obj.RHMG_M2SetHeatNode();
}

function Player::RHMG_M2SetTrigger(%obj, %val)
{
	if(%val)
		%obj.RHMG_M2TriggerDown();
	else
		%obj.RHMG_M2TriggerUp();
}


function Player::RHMG_M2TriggerDown(%obj)
{
	%obj.triggerDown = true;
	
	serverPlay3D(RHMG_M2TriggerSound, %obj.getHackPosition());
	
	cancel(%obj.RHMGFireLoop);
	%obj.schedule(80, RHMG_M2FireLoop);
	%obj.unHideNode("trigger1");
	%obj.hideNode("trigger0");
}

function Player::RHMG_M2TriggerUp(%obj)
{
	if(%obj.triggerDown)
	{
		serverPlay3D(RHMG_M2Trigger2Sound, %obj.getHackPosition());
	}

	%obj.triggerDown = false;
	
	cancel(%obj.RHMGFireLoop);
	cancel(%obj.RHMGCoolLoop);
	%obj.RHMG_M2CoolLoop();
	%obj.unHideNode("trigger0");
	%obj.hideNode("trigger1");
}

function Player::RHMG_M2FireLoop(%obj)
{
	cancel(%obj.RHMGFireLoop);
	
	if(!isObject(%obj.getMountedObject(0)))
	{
		%obj.RHMG_M2TriggerUp();
		return;
	}
	
	if(%obj.ammo <= 0)
	{
		if(!%obj.RHMG_ReloadStage)
			%obj.RHMG_M2_StartReload();
		else
		{
			if(%obj.RHMG_reloadPaused)
			{
				%obj.RHMG_reloadPaused = false;
				%obj.RHMG_M2_ContinueReload();
			}
		}
		return;
	}
	
	%obj.RHMG_M2FireOnce();
	
	if(%obj.cookoff >= 25 && $Pref::RHMG_Jamming)
	{
		%jamChance = ((%obj.cookoff - 25) / 25);
		%jamChance *= 0.05;
		if(getRandom() < %jamChance)
		{
			serverPlay3D(RHMG_RoofUpSound, %obj.getHackPosition());
			%obj.RHMG_ReloadStage = 9;
			cancel(%obj.RHMG_jamSchedule);
			%obj.RHMG_jamSchedule = %obj.schedule(300, RHMG_M2_ContinueReload);
			%obj.RHMG_M2_Jam();
			return;
		}
	}
	
	if(%obj.cookoff >= 50)
	{
		if(getRandom(1, 4) == 1 && %obj.ammo > 1)
		{
			%obj.RHMG_M2CoolLoop();
		
			%obj.RHMG_M2_Overheat();
			%obj.RHMG_ReloadStage = 8;
			%obj.playThread(0, "break");
			serverPlay3D(RHMG_HeatSound, %obj.getHackPosition());
			serverPlay3D(RHMG_RoofUpSound, %obj.getHackPosition());
			
			%obj.schedule(8000, RHMG_M2_ContinueReload);
			%obj.ammo--;
			return;
		}
	}
	
	
	if(%obj.triggerDown)
		%obj.RHMGFireLoop = %obj.schedule(100 - %obj.cookoff, RHMG_M2FireLoop);
}

function Player::RHMG_M2CoolLoop(%obj)
{
	cancel(%obj.RHMGCoolLoop);
	
	%obj.cookoff -= 0.25;
	if(%obj.cookoff < 0)
	{
		%obj.cookoff = 0;
		return;
	}
	
	if(getRandom(1, 60 - %obj.cookoff) == 1 && %obj.cookoff > 25)
	{
		if(%obj.RHMG_ReloadStage == 0)
			%obj.RHMG_M2_Jam();
		%obj.RHMG_M2FireOnce();
	}
	
	
	%barrelTrans = (%obj.cookoff / 50) * 0.25;
	%obj.setNodeColor("heat", "1 1 1" SPC %barrelTrans);
	//%obj.RHMG_M2SetHeatNode();
	
	%obj.RHMGCoolLoop = %obj.schedule(90, RHMG_M2CoolLoop);
}